function [J,fparams]=jfunp(u,params)
% JFUNP returns the Jacobian matrix wrt u of function funp,

lambda=params(1); mu=params(2);
% Coordinate vectors in e1 and e2
e1=[1; 0]; e2=[0; 1];
y1=u+e1; y2=u-e1; d1=norm(y1); d2=norm(y2);
r=( y1/d1 + y2/d2);
%f=-lambda*e2 -2*u + mu*r;
I=eye(2); % Matlab and Octave's command eye
        % return the identity matrix
J=(-2 + mu*(1/d1 + 1/d2))*I -  mu*((y1*y1')/(d1^3)...
  + (y2*y2')/(d2^3));
% partial of f wrt parameters
flambda=-e2;
% partial of f wrt parameters
fmu=r;
fparams=[flambda,fmu];
