function g=fst(f)
% fast sine transform

[m,n]=size(f); if m==1; f=f.'; [m,n]=size(f);end
N=m+1;z=zeros(1,n);
v=zeros(N,n); 
w=zeros(N/2+1,n); w(2:N/2,:)=(f(3:2:N-1,:)-f(1:2:N-3,:))/2;
w(1,:)=f(1,:); w(N/2+1,:)=-f(N-1,:);
v(1:N/2+1,:)=[z;f(2:2:m-1,:);z]+w;
v(N:-1:N/2+2,:)=-f(2:2:N-2,:)+w(2:N/2,:);
s=0.5*rfftr(v);
g=zeros(size(f));
senos=1./sin((pi/N)*[1:N/2-1]');
g(1:N/2-1,:)=s(N/2+2:N,:)+kron(senos,ones(1,n)).*s(2:N/2,:);
g(N/2,:)=s(N/2+1,:);
g(N-1:-1:N/2+1,:)=-s(N/2+2:N,:)+kron(senos,ones(1,n)).*s(2:N/2,:);
