function f=fct(x)
% FAST COSINE TRANSFORM (PERFORMED ONLY ON THE
% COLUMNS OF x IF x IS A MATRIX)
%      (lenght(x) or size(x,1) MUST BE ODD,
%       AND, BETTER 2^K + 1.
%      (returned fist and last coefs are
%       multiplied by 2).
[m,n]=size(x);
if m==1;
    N=length(x);
    f=real(ifft([x,x(N-1:-1:2)]));
    f=2*f(1:N);
else
    N=size(x,1);
    f=real(ifft([x;x(N-1:-1:2,:)]));
    f=2*f(1:N,:);
end
